# Help.tcl, added 7/15/96 to the system by Owen Mathews and Erik Goodman
#
#

proc helpDialog {fileName} {
	global env
	toplevel .helpdialog

	grab set .helpdialog
	text .helpdialog.text -yscrollcommand ".helpdialog.scroll set"
	scrollbar .helpdialog.scroll -command ".helpdialog.text yview"
	button .helpdialog.dismiss -text "Dismiss" -command "destroy .helpdialog"

	.helpdialog.text delete 1.0 end
	set infile [open $env(GALOPPS_GUI_HOME)\/$fileName]
	while {![eof $infile]} {
		.helpdialog.text insert end [read $infile 1000]
	}
	close $infile

	pack .helpdialog.dismiss -side bottom -fill x
	pack .helpdialog.text .helpdialog.scroll -side left -fill y

	tkwait window .helpdialog

	grab release .helpdialog
}
