# Input1.tcl
# This procedure is for input parameters(one)

set w .input1
catch {destroy .input1}
toplevel .input1
wm title .input1 "Input(Edit) Params (Onepop)"
wm iconname .input1 "input1"
positionWindow1 .input1

global pap
global appname
global input_for
global old_input

set input_for 1
set old_input $input_for 

set pap(app_quiet) {}
set pap(app_ckptfreq) {}
set pap(app_checkptfileprefix) {}
set pap(app_restartfileprefix) {}
set pap(app_permproblem) {}
set pap(app_alpha_size) {}
set pap(app_numfields) {}
set pap(app_superuniform) {}
set pap(app_maxgen) {}

set pap(app_popsize) {}
set pap(app_printstrings) {}
set pap(app_pcross) {}
set pap(app_pmutation) {}
set pap(app_pinversion) {}

set pap(app_autocontrol_selection) {}
set pap(app_beta_s_tilde) {}
set pap(app_beta) {}

set pap(app_scaling_window) {}
set pap(app_sigma_trunc) {}
set pap(app_scalemult) {}
set pap(app_crowding_factor) {}
set pap(app_conv_sigma_coeff) {}
set pap(app_convinterval) {}
set pap(app_incest_reduction) {}
set pap(app_randomseed) {}

frame .input1.check
frame .input1.restart
frame .input1.permproblem
frame .input1.quiet
frame .input1.ckptfreq
frame .input1.maxgen
frame .input1.numfields
frame .input1.alpha_size
frame .input1.superuniform
frame .input1.numberofruns 

frame .input1.name
frame .input1.input_for
frame .input1.button

# draw application name
label .input1.name.application -text "Application name:"
entry .input1.name.application_value -width 10 -relief sunken -bd 2 -textvariable appname
pack .input1.name.application .input1.name.application_value -side left 
set appname "mineapp.in" 
set pap(app_name) $appname

# draw numberofruns
label .input1.numberofruns.text -text "numberofruns:"
entry .input1.numberofruns.number -width 3 -relief sunken -bd 2 -textvariable numberofruns
pack .input1.numberofruns.text .input1.numberofruns.number -side left
set numberofruns 1
set pap(app_numberofruns) $numberofruns

# draw checkptfileprefix
label .input1.check.checkptfileprefix -text "Checkfileprefix:   " 
entry .input1.check.checkptfileprefix_value -width 10 -relief sunken -bd 2 -textvariable checkptfileprefix
pack .input1.check.checkptfileprefix .input1.check.checkptfileprefix_value -side left 
set checkptfileprefix {}
set pap(app_checkptfileprefix) [concat $pap(app_checkptfileprefix) $checkptfileprefix]

# draw restartfileprefix
label .input1.restart.restartfileprefix -text "Restartfileprefix: "
entry .input1.restart.restartfileprefix_value -width 10 -relief sunken -bd 2 -textvariable restartfileprefix
pack .input1.restart.restartfileprefix .input1.restart.restartfileprefix_value -side left
set restartfileprefix {}
set pap(app_restartfileprefix) [concat $pap(app_restartfileprefix) $restartfileprefix]

# draw permproblem
radiobutton .input1.permproblem.yes -text "Permproblem" -variable permproblem \
		-value y -anchor w
radiobutton .input1.permproblem.no -text "Not Permproblem" -variable permproblem \
		-value n -anchor w
pack .input1.permproblem.no .input1.permproblem.yes -side left 
set permproblem n
set pap(app_permproblem) [concat $pap(app_permproblem) $permproblem]

# draw ckptfreq
label .input1.ckptfreq.text -text "ckptfreq:      "
entry .input1.ckptfreq.number -width 3 -relief sunken -bd 2 -textvariable ckptfreq
pack .input1.ckptfreq.text .input1.ckptfreq.number -side left
set pap(app_ckptfreq) [concat $pap(app_ckptfreq) $ckptfreq]

# draw maxgen
label .input1.maxgen.text -text "maxgen:       "
entry .input1.maxgen.number -width 3 -relief sunken -bd 2 -textvariable maxgen
pack .input1.maxgen.text .input1.maxgen.number -side left -fill x
set pap(app_maxgen) [concat $pap(app_maxgen) $maxgen]

# draw numfields
label .input1.numfields.text -text "numfields:    "
entry .input1.numfields.number -width 3 -relief sunken -bd 2 -textvariable numfields
pack .input1.numfields.text .input1.numfields.number -side left -fill x
set pap(app_numfields) [concat $pap(app_numfields) $numfields]

# draw quiet
label .input1.quiet.text -text "quiet"
radiobutton .input1.quiet.0 -text "0" -variable quiet -value 0
radiobutton .input1.quiet.1 -text "1" -variable quiet -value 1
radiobutton .input1.quiet.2 -text "2" -variable quiet -value 2
radiobutton .input1.quiet.3 -text "3" -variable quiet -value 3
pack .input1.quiet.text .input1.quiet.0 .input1.quiet.1 .input1.quiet.2 .input1.quiet.3 -side left -fill x
set quiet 0
set pap(app_quiet) [concat $pap(app_quiet) $quiet]

# draw alpha_size
label .input1.alpha_size.text -text "alpha_size:   "
entry .input1.alpha_size.number -width 3 -relief sunken -bd 2 -textvariable alpha_size
pack .input1.alpha_size.text $w.alpha_size.number -side left -fill x
set pap(app_alpha_size) [concat $pap(app_alpha_size) $alpha_size]

# draw superuniform
label .input1.superuniform.text -text "superuniform:"
radiobutton .input1.superuniform.yes -text "yes" -variable superuniform -value y
radiobutton .input1.superuniform.no -text "no" -variable superuniform -value n
pack .input1.superuniform.text $w.superuniform.no $w.superuniform.yes -side left -fill x
set pap(app_superuniform) [concat $pap(app_superuniform) $superuniform]

# draw input_for
label .input1.line1 -text "=================================="
label .input1.input_for.text1 -text "Input parameters for"
entry .input1.input_for.number -width 3 -relief sunken -bd 2 -textvariable input_for
set input_for 1
label .input1.input_for.text2 -text "Run"
pack .input1.input_for.text1 $w.input_for.number $w.input_for.text2 -side left
label .input1.line2 -text "=================================="

pack .input1.name $w.numberofruns $w.check $w.restart $w.permproblem $w.quiet $w.ckptfreq 
pack .input1.maxgen $w.numfields $w.alpha_size $w.superuniform $w.line1 $w.input_for $w.line2 

# draw below
CommandEntry .input1.popsize popsize 18  -textvar popsize
CommandEntry .input1.printstrings printstrings 18  -textvar printstrings
CommandEntry .input1.pcross pcross 18  -textvar pcross
CommandEntry .input1.pmutation pmutation 18  -textvar pmutation
CommandEntry .input1.pinversion pinversion 18  -textvar pinversion

CommandEntry .input1.autocontrol_selection autocontrol_selection 18  -textvar autocontrol_selection
CommandEntry .input1.beta_s_tilde beta_s_tilde 18  -textvar beta_s_tilde
CommandEntry .input1.beta beta 18  -textvar beta

CommandEntry .input1.scaling_window scaling_window 18  -textvar scaling_window
CommandEntry .input1.sigma_trunc sigma_trunc 18  -textvar sigma_trunc
CommandEntry .input1.scalemult scalemult 18  -textvar scalemult
CommandEntry .input1.crowding_factor crowding_factor 18  -textvar crowding_factor
CommandEntry .input1.incest_reduction incest_reduction 18  -textvar incest_reduction
CommandEntry .input1.conv_sigma_coeff conv_sigma_coeff 18  -textvar conv_sigma_coeff
CommandEntry .input1.convinterval convinterval 18  -textvar convinterval
CommandEntry .input1.randomseed randomseed 18  -textvar randomseed
label .input1.line3 -text "=================================="

pack .input1.popsize $w.printstrings $w.pcross $w.pmutation $w.pinversion \
     .input1.autocontrol_selection $w.beta_s_tilde $w.beta $w.scaling_window \
     .input1.sigma_trunc $w.scalemult $w.crowding_factor $w.incest_reduction $w.conv_sigma_coeff $w.convinterval \
     .input1.randomseed $w.line3 -side top -anchor w

# draw button and command
button .input1.button.set -text "Write .in file" -command {
  set write_numberofruns [llength $pap(app_popsize)]
  if {$write_numberofruns >= $numberofruns} {
    set write_numberofruns $numberofruns
    } 
  onepop_write $write_numberofruns
}
button .input1.button.dismiss -text Dismiss -command "destroy $w"
pack .input1.button.dismiss $w.button.set -side left -expand 1
pack .input1.button

##############################
# bind for every windows event
##############################
bind .input1.name.application_value <KeyRelease> {
set pap(app_name) $appname
}

bind .input1.numberofruns.number <KeyRelease> {
set pap(app_numberofruns) $numberofruns
}

bind .input1.check.checkptfileprefix_value <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_checkptfileprefix)] == $pos } {
    set pap(app_checkptfileprefix) [concat $pap(app_checkptfileprefix) $checkptfileprefix]
 }
 if {[llength $pap(app_checkptfileprefix)] != $pos } {
    set pap(app_checkptfileprefix) [lreplace $pap(app_checkptfileprefix) $pos $pos $checkptfileprefix]
 }
}

bind .input1.restart.restartfileprefix_value <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_restartfileprefix)] == $pos } {
   set pap(app_restartfileprefix) [concat $pap(app_restartfileprefix) $restartfileprefix]
 }
 if {[llength $pap(app_restartfileprefix)] != $pos } {
   set pap(app_restartfileprefix) [lreplace $pap(app_restartfileprefix) $pos $pos $restartfileprefix]
 }
}

bind .input1.permproblem.yes <ButtonRelease-1> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_permproblem)] == $pos } {
   set pap(app_permproblem) [concat $pap(app_permproblem) $permproblem]
 }
 if {[llength $pap(app_permproblem)] != $pos } {
   set pap(app_permproblem) [lreplace $pap(app_permproblem) $pos $pos $permproblem]
 }
 set superuniform "-"
 set pos [expr $input_for - 1]
 if {[llength $pap(app_superuniform)] == $pos } {
   set pap(app_superuniform) [concat $pap(app_superuniform) $superuniform]
  }
 if {[llength $pap(app_superuniform)] != $pos } {
   set pap(app_superuniform) [lreplace $pap(app_superuniform) $pos $pos $superuniform]
  }
}
bind .input1.permproblem.no <ButtonRelease-1> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_permproblem)] == $pos } {
   set pap(app_permproblem) [concat $pap(app_permproblem) $permproblem]
 }
 if {[llength $pap(app_permproblem)] != $pos } {
   set pap(app_permproblem) [lreplace $pap(app_permproblem) $pos $pos $permproblem]
 }
}

bind .input1.quiet.0 <ButtonRelease-1> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_quiet)] == $pos } {
   set pap(app_quiet) [concat $pap(app_quiet) $quiet]
 }
 if {[llength $pap(app_quiet)] != $pos } {
   set pap(app_quiet) [lreplace $pap(app_quiet) $pos $pos $quiet]
 }
}
bind .input1.quiet.1 <ButtonRelease-1> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_quiet)] == $pos } {
   set pap(app_quiet) [concat $pap(app_quiet) $quiet]
 }
 if {[llength $pap(app_quiet)] != $pos } {
   set pap(app_quiet) [lreplace $pap(app_quiet) $pos $pos $quiet]
 }
}
bind .input1.quiet.2 <ButtonRelease-1> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_quiet)] == $pos } {
   set pap(app_quiet) [concat $pap(app_quiet) $quiet]
 }
 if {[llength $pap(app_quiet)] != $pos } {
   set pap(app_quiet) [lreplace $pap(app_quiet) $pos $pos $quiet]
 }
}
bind .input1.quiet.3 <ButtonRelease-1> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_quiet)] == $pos } {
   set pap(app_quiet) [concat $pap(app_quiet) $quiet]
 }
 if {[llength $pap(app_quiet)] != $pos } {
   set pap(app_quiet) [lreplace $pap(app_quiet) $pos $pos $quiet]
 }
}

bind .input1.ckptfreq.number <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_ckptfreq)] == $pos } {
   set pap(app_ckptfreq) [concat $pap(app_ckptfreq) $ckptfreq]
 }
 if {[llength $pap(app_ckptfreq)] != $pos } {
   set pap(app_ckptfreq) [lreplace $pap(app_ckptfreq) $pos $pos $ckptfreq]
 }
}

bind .input1.maxgen.number <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_maxgen)] == $pos } {
   set pap(app_maxgen) [concat $pap(app_maxgen) $maxgen]
 }
 if {[llength $pap(app_maxgen)] != $pos } {
   set pap(app_maxgen) [lreplace $pap(app_maxgen) $pos $pos $maxgen]
 }
}

bind .input1.numfields.number <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_numfields)] == $pos } {
   set pap(app_numfields) [concat $pap(app_numfields) $numfields]
 }
 if {[llength $pap(app_numfields)] != $pos } {
   set pap(app_numfields) [lreplace $pap(app_numfields) $pos $pos $numfields]
 }
}

bind .input1.alpha_size.number <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_alpha_size)] == $pos } {
   set pap(app_alpha_size) [concat $pap(app_alpha_size) $alpha_size]
 }
 if {[llength $pap(app_alpha_size)] != $pos } {
   set pap(app_alpha_size) [lreplace $pap(app_alpha_size) $pos $pos $alpha_size]
 }
if {$alpha_size !=2} {
 set superuniform "-"
 set pos [expr $input_for - 1]
 if {[llength $pap(app_superuniform)] == $pos } {
   set pap(app_superuniform) [concat $pap(app_superuniform) $superuniform]
  }
 if {[llength $pap(app_superuniform)] != $pos } {
   set pap(app_superuniform) [lreplace $pap(app_superuniform) $pos $pos $superuniform]
  }
 }
}

bind .input1.superuniform.yes <ButtonRelease-1> {
 set pos [expr $input_for - 1]
 set this_time_alpha_size [lindex $pap(app_alpha_size) $pos]  
 set this_time_permproblem [lindex $pap(app_permproblem) $pos]  
 if {$this_time_alpha_size == 2 && $this_time_permproblem == "n"} {
  set pos [expr $input_for - 1]
  if {[llength $pap(app_superuniform)] == $pos } {
    set pap(app_superuniform) [concat $pap(app_superuniform) $superuniform]
   }
  if {[llength $pap(app_superuniform)] != $pos } {
    set pap(app_superuniform) [lreplace $pap(app_superuniform) $pos $pos $superuniform]
   }
 }
 if {$this_time_alpha_size != 2 || $this_time_permproblem == "y"} {
   set superuniform "-"
   set pos [expr $input_for - 1]
   if {[llength $pap(app_superuniform)] == $pos } {
     set pap(app_superuniform) [concat $pap(app_superuniform) $superuniform]
   }
   if {[llength $pap(app_superuniform)] != $pos } {
     set pap(app_superuniform) [lreplace $pap(app_superuniform) $pos $pos $superuniform]
    }
  }
}
bind .input1.superuniform.no <ButtonRelease-1> {
 set pos [expr $input_for - 1]
 set this_time_alpha_size [lindex $pap(app_alpha_size) $pos]
 set this_time_permproblem [lindex $pap(app_permproblem) $pos]  
 if {$this_time_alpha_size == 2 && $this_time_permproblem == "n"} {
   set pos [expr $input_for - 1]
   if {[llength $pap(app_superuniform)] == $pos } {
     set pap(app_superuniform) [concat $pap(app_superuniform) $superuniform]
    }
   if {[llength $pap(app_superuniform)] != $pos } {
     set pap(app_superuniform) [lreplace $pap(app_superuniform) $pos $pos $superuniform]
    }
 }
 if {$this_time_alpha_size != 2 || $this_time_permproblem == "y"} {
   set superuniform "-"
   set pos [expr $input_for - 1]
   if {[llength $pap(app_superuniform)] == $pos } {
     set pap(app_superuniform) [concat $pap(app_superuniform) $superuniform]
    }
   if {[llength $pap(app_superuniform)] != $pos } {
     set pap(app_superuniform) [lreplace $pap(app_superuniform) $pos $pos $superuniform]
    }
  }
}

###################
#bind for input_for
###################
bind .input1.input_for.number <KeyRelease-Return> {
 if {$input_for <=  $numberofruns} {
  set exist_length [llength $pap(app_popsize)] 
  if {([llength $pap(app_popsize)] < $numberofruns) && ($input_for == [expr $exist_length + 1])} {
    set pap(app_quiet) [concat $pap(app_quiet) $quiet]
    set pap(app_ckptfreq) [concat $pap(app_ckptfreq) $ckptfreq]
    set pap(app_checkptfileprefix) [concat $pap(app_checkptfileprefix) $checkptfileprefix]
    set pap(app_restartfileprefix) [concat $pap(app_restartfileprefix) $restartfileprefix]
    set pap(app_permproblem) [concat $pap(app_permproblem) $permproblem]
    set pap(app_alpha_size) [concat $pap(app_alpha_size) $alpha_size]
    set pap(app_numfields) [concat $pap(app_numfields) $numfields]
    set pap(app_superuniform) [concat $pap(app_superuniform) $superuniform]
    set pap(app_maxgen) [concat $pap(app_maxgen) $maxgen]
    set pap(app_popsize) [concat $pap(app_popsize) $popsize]
    set pap(app_printstrings) [concat $pap(app_printstrings) $printstrings]
    set pap(app_pcross) [concat $pap(app_pcross) $pcross]
    set pap(app_pmutation) [concat $pap(app_pmutation) $pmutation]
    set pap(app_pinversion) [concat $pap(app_pinversion) $pinversion]

    set pap(app_autocontrol_selection) [concat $pap(app_autocontrol_selection) $autocontrol_selection]
    set pap(app_beta_s_tilde) [concat $pap(app_beta_s_tilde) $beta_s_tilde]
    set pap(app_beta) [concat $pap(app_beta) $beta]

    set pap(app_scaling_window) [concat $pap(app_scaling_window) $scaling_window]
    set pap(app_sigma_trunc) [concat $pap(app_sigma_trunc) $sigma_trunc]
    set pap(app_scalemult) [concat $pap(app_scalemult) $scalemult]
    set pap(app_crowding_factor) [concat $pap(app_crowding_factor) $crowding_factor]
    set pap(app_incest_reduction) [concat $pap(app_incest_reduction) $incest_reduction]
    set pap(app_conv_sigma_coeff) [concat $pap(app_conv_sigma_coeff) $conv_sigma_coeff]
    set pap(app_convinterval) [concat $pap(app_convinterval) $convinterval]
    set pap(app_randomseed) [concat $pap(app_randomseed) $randomseed]
    
    set old_input $input_for
    }
  if {$input_for <= $exist_length} {
    set pos [expr $input_for - 1]
    set quiet [lindex $pap(app_quiet) $pos]
    set ckptfreq [lindex $pap(app_ckptfreq) $pos]
    set checkptfileprefix [lindex $pap(app_checkptfileprefix) $pos]
    set restartfileprefix [lindex $pap(app_restartfileprefix) $pos]
    set permproblem [lindex $pap(app_permproblem) $pos]
    set alpha_size [lindex $pap(app_alpha_size) $pos]
    set numfields [lindex $pap(app_numfields) $pos]
    set superuniform [lindex $pap(app_superuniform) $pos]
    set maxgen [lindex $pap(app_maxgen) $pos]

    set popsize [lindex $pap(app_popsize) $pos]
    set printstrings [lindex $pap(app_printstrings) $pos]
    set pcross [lindex $pap(app_pcross) $pos]
    set pmutation [lindex $pap(app_pmutation) $pos]
    set pinversion [lindex $pap(app_pinversion) $pos]
    
    set autocontrol_selection [lindex $pap(app_autocontrol_selection) $pos]
    set beta_s_tilde [lindex $pap(app_beta_s_tilde) $pos]
    set beta [lindex $pap(app_beta) $pos]
    
    set scaling_window [lindex $pap(app_scaling_window) $pos]
    set sigma_trunc [lindex $pap(app_sigma_trunc) $pos]
    set scalemult [lindex $pap(app_scalemult) $pos]
    set crowding_factor [lindex $pap(app_crowding_factor) $pos]
    set incest_reduction [lindex $pap(app_incest_reduction) $pos]
    set conv_sigma_coeff [lindex $pap(app_conv_sigma_coeff) $pos]
    set convinterval [lindex $pap(app_convinterval) $pos]
    set randomseed [lindex $pap(app_randomseed) $pos]

    set old_input $input_for
  }
 }
 set input_for $old_input
# puts stdout [array get pap]
}

bind .input1.popsize.entry <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_popsize)] == $pos } {
   set pap(app_popsize) [concat $pap(app_popsize) $popsize]
 }
 if {[llength $pap(app_popsize)] != $pos } {
   set pap(app_popsize) [lreplace $pap(app_popsize) $pos $pos $popsize]
 }
}

bind .input1.printstrings.entry <KeyRelease> {
 if {$printstrings == "y"} {
    set printstrings y
    set pos [expr $input_for - 1]
    if {[llength $pap(app_printstrings)] == $pos } {
      set pap(app_printstrings) [concat $pap(app_printstrings) $printstrings]
    }
    if {[llength $pap(app_printstrings)] != $pos } {
      set pap(app_printstrings) [lreplace $pap(app_printstrings) $pos $pos $printstrings]
    }
    break
 }
 if {$printstrings == "n"} {
    set printstrings n
    set pos [expr $input_for - 1]
    if {[llength $pap(app_printstrings)] == $pos } {
       set pap(app_printstrings) [concat $pap(app_printstrings) $printstrings]
    }
    if {[llength $pap(app_printstrings)] != $pos } {
       set pap(app_printstrings) [lreplace $pap(app_printstrings) $pos $pos $printstrings]
    }
    break
 }
 set printstrings {}
 set pos [expr $input_for - 1]
 if {[llength $pap(app_printstrings)] == $pos } {
   set pap(app_printstrings) [concat $pap(app_printstrings) $printstrings]
 }
 if {[llength $pap(app_printstrings)] != $pos } {
   set pap(app_printstrings) [lreplace $pap(app_printstrings) $pos $pos $printstrings]
 }
}

bind .input1.pcross.entry <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_pcross)] == $pos } {
   set pap(app_pcross) [concat $pap(app_pcross) $pcross]
 }
 if {[llength $pap(app_pcross)] != $pos } {
   set pap(app_pcross) [lreplace $pap(app_pcross) $pos $pos $pcross]
 }
}

bind .input1.pmutation.entry <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_pmutation)] == $pos } {
   set pap(app_pmutation) [concat $pap(app_pmutation) $pmutation]
 }
 if {[llength $pap(app_pmutation)] != $pos } {
   set pap(app_pmutation) [lreplace $pap(app_pmutation) $pos $pos $pmutation]
 }
}

bind .input1.pinversion.entry <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_pinversion)] == $pos } {
   set pap(app_pinversion) [concat $pap(app_pinversion) $pinversion]
 }
 if {[llength $pap(app_pinversion)] != $pos } {
   set pap(app_pinversion) [lreplace $pap(app_pinversion) $pos $pos $pinversion]
 }
}
#$$$$$$$$$$
bind .input1.autocontrol_selection.entry <KeyRelease> {
 if {$autocontrol_selection == "y"} {
   set autocontrol_selection y
   set pos [expr $input_for - 1]
   if {[llength $pap(app_autocontrol_selection)] == $pos } {
    set pap(app_autocontrol_selection) [concat $pap(app_autocontrol_selection) $autocontrol_selection]
    }
   if {[llength $pap(app_autocontrol_selection)] != $pos } {
    set pap(app_autocontrol_selection) [lreplace $pap(app_autocontrol_selection) $pos $pos $autocontrol_selection]
    }
  
   set beta "-"
   set pos [expr $input_for - 1]
   if {[llength $pap(app_beta)] == $pos } {
     set pap(app_beta) [concat $pap(app_beta) $beta]
     }
   if {[llength $pap(app_beta)] != $pos } {
     set pap(app_beta) [lreplace $pap(app_beta) $pos $pos $beta]
     }

   set scaling_window "-"
   set pos [expr $input_for - 1]
   if {[llength $pap(app_scaling_window)] == $pos } {
     set pap(app_scaling_window) [concat $pap(app_scaling_window) $scaling_window]
    }
   if {[llength $pap(app_scaling_window)] != $pos } {
     set pap(app_scaling_window) [lreplace $pap(app_scaling_window) $pos $pos $scaling_window]
   }

   set sigma_trunc "-"
   set pos [expr $input_for - 1]
   if {[llength $pap(app_sigma_trunc)] == $pos } {
     set pap(app_sigma_trunc) [concat $pap(app_sigma_trunc) $sigma_trunc]
    }
   if {[llength $pap(app_sigma_trunc)] != $pos } {
     set pap(app_sigma_trunc) [lreplace $pap(app_sigma_trunc) $pos $pos $sigma_trunc]
    }
 
   set scalemult "-"
   set pos [expr $input_for - 1]
   if {[llength $pap(app_scalemult)] == $pos } {
     set pap(app_scalemult) [concat $pap(app_scalemult) $scalemult]
    }
   if {[llength $pap(app_scalemult)] != $pos } {
     set pap(app_scalemult) [lreplace $pap(app_scalemult) $pos $pos $scalemult]
    }
   break
  }
 if {$autocontrol_selection == "n"} {
   set autocontrol_selection n
   set pos [expr $input_for - 1]
   if {[llength $pap(app_autocontrol_selection)] == $pos } {
     set pap(app_autocontrol_selection) [concat $pap(app_autocontrol_selection) $autocontrol_selection]
    }
   if {[llength $pap(app_autocontrol_selection)] != $pos } {
     set pap(app_autocontrol_selection) [lreplace $pap(app_autocontrol_selection) $pos $pos $autocontrol_selection]
    }
  
   set beta_s_tilde "-"
   set pos [expr $input_for - 1]
   if {[llength $pap(app_beta_s_tilde)] == $pos } {
    set pap(app_beta_s_tilde) [concat $pap(app_beta_s_tilde) $beta_s_tilde]
    }
   if {[llength $pap(app_beta_s_tilde)] != $pos } {
    set pap(app_beta_s_tilde) [lreplace $pap(app_beta_s_tilde) $pos $pos $beta_s_tilde]
    }
   break
  } 
  set autocontrol_selection {}
  set pos [expr $input_for - 1]
  if {[llength $pap(app_autocontrol_selection)] == $pos } {
  set pap(app_autocontrol_selection) [concat $pap(app_autocontrol_selection) $autocontrol_selection]
 }
 if {[llength $pap(app_autocontrol_selection)] != $pos } {
   set pap(app_autocontrol_selection) [lreplace $pap(app_autocontrol_selection) $pos $pos $autocontrol_selection]
 }
}

bind .input1.beta_s_tilde.entry <Key> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_beta_s_tilde)] == $pos } {
   set pap(app_beta_s_tilde) [concat $pap(app_beta_s_tilde) $beta_s_tilde]
   }
 if {[llength $pap(app_beta_s_tilde)] != $pos } {
   set pap(app_beta_s_tilde) [lreplace $pap(app_beta_s_tilde) $pos $pos $beta_s_tilde]
   }
}
bind .input1.beta_s_tilde.entry <KeyRelease> {
 if {$autocontrol_selection == "y"} {
   set pos [expr $input_for - 1]
   if {[llength $pap(app_beta_s_tilde)] == $pos } {
    set pap(app_beta_s_tilde) [concat $pap(app_beta_s_tilde) $beta_s_tilde]
    }
   if {[llength $pap(app_beta_s_tilde)] != $pos } {
    set pap(app_beta_s_tilde) [lreplace $pap(app_beta_s_tilde) $pos $pos $beta_s_tilde]
    }
 break
 }
 set beta_s_tilde "-"
}

bind .input1.beta.entry <Key> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_beta)] == $pos } {
   set pap(app_beta) [concat $pap(app_beta) $beta]
 }
 if {[llength $pap(app_beta)] != $pos } {
   set pap(app_beta) [lreplace $pap(app_beta) $pos $pos $beta]
 }
}
bind .input1.beta.entry <KeyRelease> {
 if {$autocontrol_selection == "n"} {
   set pos [expr $input_for - 1]
   if {[llength $pap(app_beta)] == $pos } {
     set pap(app_beta) [concat $pap(app_beta) $beta]
    }
   if {[llength $pap(app_beta)] != $pos } {
     set pap(app_beta) [lreplace $pap(app_beta) $pos $pos $beta]
    }
 break
 }
 set beta "-"
}

#$$$$$$$$$$
bind .input1.scaling_window.entry <KeyRelease> {
if {$autocontrol_selection != "y" } {
 if {$scaling_window != -1} {
   set sigma_trunc "-"
   set pos [expr $input_for - 1]
   if {[llength $pap(app_sigma_trunc)] == $pos } {
     set pap(app_sigma_trunc) [concat $pap(app_sigma_trunc) $sigma_trunc]
   }
   if {[llength $pap(app_sigma_trunc)] != $pos } {
     set pap(app_sigma_trunc) [lreplace $pap(app_sigma_trunc) $pos $pos $sigma_trunc]
   }
   set scalemult "-"
   set pos [expr $input_for - 1]
   if {[llength $pap(app_scalemult)] == $pos } {
     set pap(app_scalemult) [concat $pap(app_scalemult) $scalemult]
   }
   if {[llength $pap(app_scalemult)] != $pos } {
     set pap(app_scalemult) [lreplace $pap(app_scalemult) $pos $pos $scalemult]
   }
 }
 if {$scaling_window >= -1 && $scaling_window <= 20.0} {
   set pos [expr $input_for - 1]
   if {[llength $pap(app_scaling_window)] == $pos } {
     set pap(app_scaling_window) [concat $pap(app_scaling_window) $scaling_window]
   }
   if {[llength $pap(app_scaling_window)] != $pos } {
     set pap(app_scaling_window) [lreplace $pap(app_scaling_window) $pos $pos $scaling_window]
   }
  }
 break
 }
set scaling_window "-"
}

bind .input1.sigma_trunc.entry  <Key> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_sigma_trunc)] == $pos } {
  set pap(app_sigma_trunc) [concat $pap(app_sigma_trunc) $sigma_trunc]
 }
 if {[llength $pap(app_sigma_trunc)] != $pos } {
  set pap(app_sigma_trunc) [lreplace $pap(app_sigma_trunc) $pos $pos $sigma_trunc]
 }
}
bind .input1.sigma_trunc.entry  <KeyRelease> {
 if {$scaling_window == -1 && $autocontrol_selection != "y"} {
  set pos [expr $input_for - 1]
  if {[llength $pap(app_sigma_trunc)] == $pos } {
   set pap(app_sigma_trunc) [concat $pap(app_sigma_trunc) $sigma_trunc]
  }
  if {[llength $pap(app_sigma_trunc)] != $pos } {
   set pap(app_sigma_trunc) [lreplace $pap(app_sigma_trunc) $pos $pos $sigma_trunc]
  }
  break
 }
 set sigma_trunc "-"
}

bind .input1.scalemult.entry <Key> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_scalemult)] == $pos } {
   set pap(app_scalemult) [concat $pap(app_scalemult) $scalemult]
 }
 if {[llength $pap(app_scalemult)] != $pos } {
   set pap(app_scalemult) [lreplace $pap(app_scalemult) $pos $pos $scalemult]
 }
}
bind .input1.scalemult.entry <KeyRelease> {
 if {$scaling_window == -1 && $autocontrol_selection != "y"} {
   set pos [expr $input_for - 1]
   if {[llength $pap(app_scalemult)] == $pos } {
     set pap(app_scalemult) [concat $pap(app_scalemult) $scalemult]
   }
   if {[llength $pap(app_scalemult)] != $pos } {
     set pap(app_scalemult) [lreplace $pap(app_scalemult) $pos $pos $scalemult]
   }
   break
  }
 set scalemult "-"
}

bind .input1.crowding_factor.entry <KeyRelease> {
 if {$crowding_factor >=0 && $crowding_factor <= 5} {
   set pos [expr $input_for - 1]
   if {[llength $pap(app_crowding_factor)] == $pos } {
     set pap(app_crowding_factor) [concat $pap(app_crowding_factor) $crowding_factor]
   }
   if {[llength $pap(app_crowding_factor)] != $pos } {
     set pap(app_crowding_factor) [lreplace $pap(app_crowding_factor) $pos $pos $crowding_factor]
   }
 }
 if {$crowding_factor == 0 || $crowding_factor < 1.0} {
   set incest_reduction "-"
   set pos [expr $input_for - 1]
   if {[llength $pap(app_incest_reduction)] == $pos } {
    set pap(app_incest_reduction) [concat $pap(app_incest_reduction) $incest_reduction]
   }
   if {[llength $pap(app_incest_reduction)] != $pos } {
    set pap(app_incest_reduction) [lreplace $pap(app_incest_reduction) $pos $pos $incest_reduction]
   }
 }
}

bind .input1.incest_reduction.entry <KeyRelease> {
 if {$crowding_factor > 0} {
    set pos [expr $input_for - 1]
    if {[llength $pap(app_incest_reduction)] == $pos } {
      set pap(app_incest_reduction) [concat $pap(app_incest_reduction) $incest_reduction]
    }
   if {[llength $pap(app_incest_reduction)] != $pos } {
      set pap(app_incest_reduction) [lreplace $pap(app_incest_reduction) $pos $pos $incest_reduction]
    }
   break
 }
 set incest_reduction "-"
}

bind .input1.conv_sigma_coeff.entry <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_conv_sigma_coeff)] == $pos } {
   set pap(app_conv_sigma_coeff) [concat $pap(app_conv_sigma_coeff) $conv_sigma_coeff]
 }
 if {[llength $pap(app_conv_sigma_coeff)] != $pos } {
   set pap(app_conv_sigma_coeff) [lreplace $pap(app_conv_sigma_coeff) $pos $pos $conv_sigma_coeff]
 }
}

bind .input1.convinterval.entry <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_convinterval)] == $pos } {
   set pap(app_convinterval) [concat $pap(app_convinterval) $convinterval]
 }
 if {[llength $pap(app_convinterval)] != $pos } {
   set pap(app_convinterval) [lreplace $pap(app_convinterval) $pos $pos $convinterval]
 }
}

bind .input1.randomseed.entry <KeyRelease> {
 set pos [expr $input_for - 1]
 if {[llength $pap(app_randomseed)] == $pos } {
   set pap(app_randomseed) [concat $pap(app_randomseed) $randomseed]
 }
 if {[llength $pap(app_randomseed)] != $pos } {
   set pap(app_randomseed) [lreplace $pap(app_randomseed) $pos $pos $randomseed]
 }
}

