REM Continuation file for use in solving Royal Road problem using
REM a multi-pop approach, trying to minimize number of function
REM evaluations.  ASSUMES user has already run royrdst1.in to create
REM files royst100.ckp, royst100.ind, ..., royst123.ckp, royst123.ind and
REM files royst199.stt and zoyst199.stt.
REM Uses these "canned" files to initialize next stage, just to save in number
REM of total evaluations needed.
copy royst103.ind royst124.ind
copy royst103.ckp royst124.ckp
copy royst106.ind royst125.ind
copy royst106.ckp royst125.ckp
copy royst109.ind royst126.ind
copy royst109.ckp royst126.ckp
copy royst112.ind royst127.ind
copy royst112.ckp royst127.ckp
copy royst115.ind royst128.ind
copy royst115.ckp royst128.ckp
copy royst118.ind royst129.ind
copy royst118.ckp royst129.ckp
copy royst121.ind royst130.ind
copy royst121.ckp royst130.ckp
copy royst100.ind royst131.ind
copy royst100.ckp royst131.ckp
copy royst199.stt royst299.stt
copy zoyst199.stt zoyst299.stt
REM Now copy these stage 1 files to stage 2 names for use in second
REM stage, royrdst2.in.  These files will be stagnant rest of run.
REM Use of a different name (st2 instead of st1) allows user to redo
REM later stages of run without waiting for stage 1 to run again, while
REM preserving an accurate count of evaluations to reach a particular point.
copy royst100.ind royst200.ind
copy royst101.ind royst201.ind
copy royst102.ind royst202.ind
copy royst103.ind royst203.ind
copy royst104.ind royst204.ind
copy royst105.ind royst205.ind
copy royst106.ind royst206.ind
copy royst107.ind royst207.ind
copy royst108.ind royst208.ind
copy royst109.ind royst209.ind
copy royst110.ind royst210.ind
copy royst111.ind royst211.ind
copy royst112.ind royst212.ind
copy royst113.ind royst213.ind
copy royst114.ind royst214.ind
copy royst115.ind royst215.ind
copy royst116.ind royst216.ind
copy royst117.ind royst217.ind
copy royst118.ind royst218.ind
copy royst119.ind royst219.ind
copy royst120.ind royst220.ind
copy royst121.ind royst221.ind
copy royst122.ind royst222.ind
copy royst123.ind royst223.ind
manypops -i  royrdst2.in -o royrdst2.out
copy royst224.ind royst232.ind
copy royst224.ckp royst232.ckp
copy royst225.ind royst233.ind
copy royst225.ckp royst233.ckp
copy royst226.ind royst234.ind
copy royst226.ckp royst234.ckp
copy royst227.ind royst235.ind
copy royst227.ckp royst235.ckp
copy royst228.ind royst236.ind
copy royst228.ckp royst236.ckp
copy royst229.ind royst237.ind
copy royst229.ckp royst237.ckp
copy royst230.ind royst238.ind
copy royst230.ckp royst238.ckp
manypops -i  royrdst3.in -o royrdst3.out
manypops -i  royrdst4.in -o royrdst4.out                     
manypops -i  royrdst5.in -o royrdst5.out

